package com.link.core.basic.dao.mapper;

import com.link.core.basic.model.BasicModel;
import java.util.List;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.mapping.ResultSetType;
import org.apache.ibatis.session.ResultHandler;

public interface BasicMapper<T extends BasicModel> {
   void insert(T entity) throws Exception;

   void batchInsert(List<T> list) throws Exception;

   Integer update(T entity) throws Exception;

   T queryById(T entity) throws Exception;

   Integer deleteById(T entity) throws Exception;

   List<T> queryAll(T entity) throws Exception;

   List<T> queryByExamplePage(T entity) throws Exception;

   @Options(
      resultSetType = ResultSetType.FORWARD_ONLY,
      fetchSize = 1000
   )
   void streamQueryAll(T entity, ResultHandler<T> resultHandler) throws Exception;
}
